/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2009-2013 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 */
#ifndef TOPPERS_TARGET_IPI_H
#define TOPPERS_TARGET_IPI_H

#include "mpcore.h"

/*
 *  Numbers for software generated interrupts SGI
 */
#ifdef TOPPERS_SAFEG_SECURE
#define IPINO_DIS  DIC_IRQNO_IPI14
#define IPINO_EXT  DIC_IRQNO_IPI15
#else  /* !TOPPERS_SAFEG_SECURE */
#define IPINO_DIS  DIC_IRQNO_IPI0
#define IPINO_EXT  DIC_IRQNO_IPI1
#endif /* TOPPERS_SAFEG_SECURE */

/*
 *  Priority for inter-processor interrupts used for dispatching requests
 */
#ifdef TOPPERS_SAFEG_SECURE
#define INTPRI_IPI_DIS_PRC1   (-16)
#define INTPRI_IPI_DIS_PRC2   (-16)
#define INTPRI_IPI_DIS_PRC3   (-16)
#define INTPRI_IPI_DIS_PRC4   (-16)
#else  /* !TOPPERS_SAFEG_SECURE */
#define INTPRI_IPI_DIS_PRC1   (-2)
#define INTPRI_IPI_DIS_PRC2   (-2)
#define INTPRI_IPI_DIS_PRC3   (-2)
#define INTPRI_IPI_DIS_PRC4   (-2)
#endif /* TOPPERS_SAFEG_SECURE */

/*
 *  Priority for inter-processor interrupts used when the kernel ends
 */
#ifdef TOPPERS_SAFEG_SECURE
#define INTPRI_IPI_EXT_PRC1   (-31)
#define INTPRI_IPI_EXT_PRC2   (-31)
#define INTPRI_IPI_EXT_PRC3   (-31)
#define INTPRI_IPI_EXT_PRC4   (-31)
#else  /* !TOPPERS_SAFEG_SECURE */
#define INTPRI_IPI_EXT_PRC1   (-15)
#define INTPRI_IPI_EXT_PRC2   (-15)
#define INTPRI_IPI_EXT_PRC3   (-15)
#define INTPRI_IPI_EXT_PRC4   (-15)
#endif /* TOPPERS_SAFEG_SECURE */

/*
 *  Include chip configuration (MPCORE)
 */
#include "arm_gcc/mpcore/chip_ipi.h"

#endif /* TOPPERS_TARGET_IPI_H */
