/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2008-2015 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 */
#ifndef TOPPERS_TARGET_SYSSVC_H
#define TOPPERS_TARGET_SYSSVC_H

#include "socfpga.h"
#include "arm_gcc/mpcore/mpcore.h"

/*
 *  Enable trace (use the ENABLE_TRACE flag at the app's Makefile)
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  Name that appears in the initialization message to
 *  show the target system
 */
#define TARGET_NAME "Altera SOCFPGA Cyclone 5"

/*
 *  Omit NS16550 CLK init, init is done by spl.
 */
#define OMIT_NS16550_CLK_INIT

/*
 *  System log low-level character output
 */
extern void target_fput_log(char c);

/*
 *  Supported serial ports
 */
#define TNUM_PORT   1

#ifdef TOPPERS_SAFEG_SECURE
#define INTPRI_SIO1       -19             /* UARTͥ */
#define INTPRI_SIO2       -19             /* UARTͥ */
#else /* !TOPPERS_SAFEG_SECURE */
#define INTPRI_SIO1       -2              /* UARTͥ */
#define INTPRI_SIO2       -2              /* UARTͥ */
#endif /* TOPPERS_SAFEG_SECURE */

#define INTATR_SIO1       0U              /* UART° */
#define INTATR_SIO2       0U              /* UART° */

#endif /* TOPPERS_TARGET_SYSSVC_H */
